﻿namespace Butterfly.HabboHotel.Items.Interactors
{
    using Butterfly.HabboHotel.GameClients;
    using Butterfly.HabboHotel.Items;
    using Butterfly.HabboHotel.Rooms;
    using System;

    internal class InteractorDice : FurniInteractor
    {
        internal override void OnPlace(GameClient Session, RoomItem Item)
        {
        }

        internal override void OnRemove(GameClient Session, RoomItem Item)
        {
        }

        internal override void OnTrigger(GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            RoomUser roomUserByHabbo = null;
            if (Session != null)
            {
                roomUserByHabbo = Item.GetRoom().GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
            }
            if (roomUserByHabbo != null)
            {
                if (Gamemap.TilesTouching(Item.GetX, Item.GetY, roomUserByHabbo.X, roomUserByHabbo.Y))
                {
                    if (Item.ExtraData != "-1")
                    {
                        if (Request == -1)
                        {
                            Item.ExtraData = "0";
                            Item.UpdateState();
                        }
                        else
                        {
                            Item.ExtraData = "-1";
                            Item.UpdateState(false, true);
                            Item.ReqUpdate(4, true);
                        }
                    }
                }
                else
                {
                    roomUserByHabbo.MoveTo(Item.SquareInFront);
                }
            }
        }
    }
}

